QGIS Application - Bug report #20131
[3d] Navigation in 3d map and locked left click
2018-10-17 11:59 AM - Saber Razmjooei

Status: Closed
Priority: Normal
Assignee:

Category: 3D

Affected QGIS version:3.3(master)
Operating System:

Pull Request or Patch supplied:
Crashes QGIS or corrupls data:

Regression?: No
Easy fix?: No
Resolution:

Copied to github as #: 27952

Description

It happens a lot of times, when panning (using left-click and drag) the map gets stuck and panning does not work any more.

After using a combination of other keys and clicks it eventually gets unlocked but it after a couple of attempts, it gets locked again.

Here is my example project:

https://www.dropbox.com/s/emqgb4zj77929zmo/3d_navigation left click.zip

Associated revisions

Revision fbde0c87 - 2018-11-06 05:23 PM - Martin Dobias

[3d] fix camera controller using wrong shift/ctrl status (fixes #20131)

We used Qt3DInput::QLogicalDevice with its axes and actions for camera
controller, but over time this got quite impractical, moreover we started

to have problems with shift/ctrl actions getting stuck in wrong state

in case they were pressed or released while 3D canvas was not focused
(which is in fact relatively common when using other widgets in the GUI)

This commit switches over to using just QMouseHandler and QKeyboardHandler
for handling key and mouse events and this not only makes the code easier

to read, but also the issues with shift/ctrl go away (because we do not

keep their status anymore, we just check whether they are active inside

event handlers).

The speed of change with mouse wheel and keys should be similar or a bit
less than what it was before.

Revision 7¢4708e0 - 2018-11-22 01:06 PM - Martin Dobias

[3d] fix camera controller using wrong shift/ctrl status (fixes #20131)

We used Qt3DInput::QLogicalDevice with its axes and actions for camera
controller, but over time this got quite impractical, moreover we started

to have problems with shift/ctrl actions getting stuck in wrong state

in case they were pressed or released while 3D canvas was not focused

(which is in fact relatively common when using other widgets in the GUI)

This commit switches over to using just QMouseHandler and QKeyboardHandler
https://www.dropbox.com/s/emqb4zj7792qzmo/3d_navigation_left_click.zip

for handling key and mouse events and this not only makes the code easier
to read, but also the issues with shift/ctrl go away (because we do not

keep their status anymore, we just check whether they are active inside
event handlers).

The speed of change with mouse wheel and keys should be similar or a bit
less than what it was before.

(cherry picked from commit fbde0c8752740358fdb9bf9c232f72badfa1e87b)

History

#1 - 2018-11-06 05:22 PM - Martin Dobias
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|fbde0c8752740358fdb9bf9c232f72badfale87b.
